'-- This is a demo file for the jsHTTP.exe FileOps object.
'-- decompressing Flash files has limited usefulness. One reason
'-- to do it might be to search for an FLV file path. (Sometimes
'-- when Flash is used to stream FLV files, the actual FLV path is in
'-- the SWF file, hard-coded.) But the main point of this script
'-- is just to provide a demo of FileOps, and SWF files are one example
'-- of a situation where gzip compression is used in files. It lends itself
'-- to this demo because of Flash file format: Most swf files are compressed
'-- with gzip compression. The way it works is that the first 8 bytes are
'-- a brief header and the rest of the file is compressed. It works like so:

'-- C-W-S-V-N-N-N-N    A compressed SWF starts with "CWF", then has a 1-byte version number,
'-- then 4 bytes that indicate the original file size, which is needed for decompressing. The rest
'-- of the file is compressed. If a flash file is not compressed it starts with "FWS".


Dim sFilPath, FO, s1, s2, i2, Ret, A1, A2(), LenFil
'On Error Resume Next
  sFilPath = WScript.Arguments(0)
If Len(sFilPath) = 0 Then
   MsgBox "Drop a file onto script for this demo."
   WScript.Quit
End If

If UCase(Right(sFilPath, 3)) <> "SWF" Then
   MsgBox "This script is a demo of decompressing flash files. The file dropped must be an SWF file."
   WScript.Quit
End If


Set FO = CreateObject("jsHTTP2.FileOps")

Ret = FO.OpenFile(sFilPath)
   If Ret <> 0 Then    
      MsgBox "Error. Problem opening file. Error:" & vbCrLf & FO.ErrorString & vbCrLf & "Script must quit.", 64
      DropIt
  End If

  Ret = FO.FileRead(1, 8, "head") 
  Ret = FO.GetBytes("head", 1, 3, A1)  '-- check the compressed flash signature bytes.
                             '-- read in the compressed section:
  For i2 = 0 to 2
    s2 = s2 & Chr(A1(i2))
  Next
    If s2 <> "CWS" Then
      FO.CloseFile
      MsgBox "This is not a compressed flash file.", 64
      DropIt
   End If
   
 Ret = FO.FileRead(9, 0, "body")
 FO.CloseFile
   If Ret <> 0 Then    
      MsgBox "Error. Problem reading body of file. Error:" & vbCrLf & FO.ErrorString & vbCrLf & "Script must quit.", 64
      DropIt
  End If
  
Erase A1 
Ret = FO.GetBytes("head", 5, 4, A1)  '-- get the file length.
  If Ret <> 0 Then 
       MsgBox "Error. Problem getting file size bytes. Error:" & vbCrLf & FO.ErrorString & vbCrLf & "Script must quit.", 64
      DropIt
  End If

LenFil = FO.BytesToLong(A1)
  If FO.ErrorNumber <> 0 Then
     MsgBox "Error. Problem getting file length. Error:" & vbCrLf & FO.ErrorString & vbCrLf & "Script must quit.", 64
     DropIt
  End If
    
Ret = FO.Unzip("body", LenFil)
   If Ret <> 0 Then
      MsgBox "Error. Unzipping failed. Error:" & vbCrLf & FO.ErrorString & vbCrLf & "Script must quit.", 64
      DropIt
  End If
  
  '-- save the file header but change "C" to "F".
ReDim A2(0)
A2(0) = Asc("F")
Ret = FO.ReplaceBytes("head", 1, A2)
  If Ret <> 0 Then
      MsgBox "Error when replacing first byte. Error:" & vbCrLf & FO.ErrorString & vbCrLf & "Script must quit.", 64
      DropIt
  End If
  
Ret = FO.OpenFile(sFilPath & ".UNZIPPED.swf")
  Ret = FO.FileWrite(1, "head")
  Ret = FO.FileWrite(0, "body")
  FO.CloseFile
  
DropIt
     
Sub DropIt()
    Set FO = Nothing
    MsgBox "End of script.", 64
   WScript.Quit
End Sub
