'-- jsHTTP demo. This demo uses all of the methods in the FileOps object.
'-- This script was tested by dropping the file zlibwapi.dll onto it. Zlibwapi.dll
'-- is the free DLL used by jsHTTP2 to perform gzip operations. jsHTTP2.exe
'-- contains an embedded copy of zlibwapi.dll, writing out a copy to disk as
'-- needed. (A copy is written to the path of jsHTTP2 whenever the FileOps
'-- object is created -- if zlibwapi.dll is not already present. So, if you want
'-- to use zlibwapi.dll for this test you can just write a msall script first to
'-- create the object.


Dim sFilPath, FO, s1, s2, i2, Ret, A1(), A2, Abmp, LenBZLib

On Error Resume Next
  sFilPath = WScript.Arguments(0)
If Len(sFilPath) = 0 Then
   MsgBox "Drop a file onto script for this demo."
   WScript.Quit
End If
On Error GoTo 0
Set FO = CreateObject("jsHTTP2.FileOps")

'----------------- BytesToLong ------------------------------
ReDim A1(3)
  A1(0) = 8
  A1(1) = 4
  A1(2) = 6
  A1(3) = 1
Ret = FO.BytesToLong(A1)
 If FO.ErrorNumber <> 0 Then
     ShowError2 "BytesToLong"
 Else
    MsgBox "BytesToLong returns " & Ret
 End If

'----------------------- LongToBytes -------------------------
 '-- must use plain variant variable for this. Any type of array will result in type mismatch error.
A2 = FO.LongToBytes(Ret)
   If FO.ErrorNumber <> 0 Then
     ShowError2 "LongToBytes"
   Else
     MsgBox "LongToBytes should return 8 4 6 1. Result is: " & vbCrLf & A2(0) & " " & A2(1) & " " & A2(2) & " " & A2(3)
   End If
   
'-- write a 1x16 pixel bitmap to disk by first storing the bytes in FileOps, then using FileOps to write the data to disk.

Abmp = Array(66, 77, 118, 0, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 40, 0, 0, 0, 1, 0, 0, 0, 16, 0, 0, 0, 1, 0, 24, 0, 0, 0, 0, 0, 64, 0, 0, 0, 18, 11, 0, 0, 18, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 21, 21, 0, 147, 31, 31, 0, 159, 43, 43, 0, 169, 53, 53, 0, 188, 62, 65, 0, 202, 69, 72, 0, 216, 80, 83, 0, 227, 90, 93, 0, 231, 92, 95, 0, 220, 84, 87, 0, 206, 72, 75, 0, 193, 63, 66, 0, 174, 56, 56, 0, 163, 47, 47, 0, 150, 34, 34, 0, 140, 24, 24, 0)
Ret = FO.StoreBytes("bmp", Abmp)
   If Ret <> 0 Then ShowError1 Ret, "StoreBytes": DropIt  
Ret = FO.OpenFile(sFilPath & ".bmp")
   If Ret <> 0 Then ShowError1 Ret, "OpenFile to write BMP": DropIt  
Ret = FO.FileWrite(1, "bmp")
   If Ret <> 0 Then ShowError1 Ret, "FileWrite - writing BMP file": DropIt  
 FO.CloseFile

 '-- open the file dropped onto script.
Ret = FO.OpenFile(sFilPath)  
    If Ret <> 0 Then ShowError1 Ret, "OpenFile": DropIt  
Ret = FO.FileRead(1, 0, "one")  '-- read entire file into storage.
   If Ret <> 0 Then ShowError1 Ret, "FileRead": DropIt  
LenBZLib = FO.GetStoreSize("one")
   If FO.ErrorNumber <> 0 Then ShowError2 "GetStoreSize": DropIt
Ret = FO.GetBytes("one", 79, 39, A2)   '-- Get an array of bytes from given offset, of given size.
   If Ret <> 0 Then ShowError1 Ret, "GetBytes": DropIt  
For i2 = 0 to UBound(A2)
  s2 = s2 & Chr(A2(i2))
Next

 '-- If zlibwapi is dropped onto script then s2 should contain "This program cannot be run in DOS mode."
  MsgBox "Bytes translated to characters reads:" & vbCrLf & s2
 Ret = FO.CopyBytes("one", 79, 39, "two", 1)  '-- "two" does not exist so it gets created.
   If Ret <> 0 Then ShowError1 Ret, "CopyBytes": DropIt  
   ReDim A1(2)
   For i2 = 0 to 2
       A1(i2) = 90  '-- ASCII code for "Z"
   Next
Ret = FO.ReplaceBytes("two", 24, A1) '-- if file was zlibwapi.dll then the bytes in "two" should now read: "This program cannot be ZZZ in DOS mode."
  If Ret <> 0 Then ShowError1 Ret, "ReplaceBytes": DropIt  
  
 FO.CloseFile

'-- write a new file with bytes copied between stores.
Ret = FO.OpenFile(sFilPath & ".dat")
   If Ret <> 0 Then ShowError1 Ret, "Creating new file with OpenFile": DropIt  
Ret = FO.FileWrite(1, "two")
   If Ret <> 0 Then ShowError1 Ret, "FileWrite": DropIt  
Ret = FO.FileWrite(0, "two")  '-- add same string at end of file.
   If Ret <> 0 Then ShowError1 Ret, "Second FileWrite": DropIt  
   
  FO.CloseFile
  
  '-- ZIP demo: First, zip the dropped file in memory using Zip and then write it to disk.
  '-- Then unzip that file to a new file using UnzipFile.
  '-- To test all methods, also do the reverse: Zip a file from disk using ZipFile, then open that,
  '-- unzip it in memory using Unzip, and write the result to disk.
  
Ret = FO.Zip("one")  '-- zip the DLL.
   If Ret <> 0 Then ShowError1 Ret, "Zip": DropIt  
Ret = FO.OpenFile(sFilPath & ".datZ")  '-- write the zipped file to disk.
  If Ret <> 0 Then ShowError1 Ret, "OpenFile to write zipped data to disk": DropIt  
Ret = FO.FileWrite(1, "one")  
   If Ret <> 0 Then ShowError1 Ret, "FileWrite zipped bytes": DropIt  
FO.CloseFile  '-- file cannot be reopened and unzipped until it's been closed. Error 70, permission denied, is typically caused by an error here.

Ret = FO.OpenFile(sFilPath & ".datZ")  '-- open the zipped file, read it in, then unzip it as a byte array.  
   If Ret <> 0 Then ShowError1 Ret, "OpenFile - opening zipped file": DropIt  
Ret = FO.FileRead(1, 0, "zip")  '-- read entire file into storage.
   If Ret <> 0 Then ShowError1 Ret, "FileRead - reading zipped file": DropIt  
 FO.CloseFile  
Ret = FO.Unzip("zip", LenBZLib)
   If Ret <> 0 Then ShowError1 Ret, "Unzip - unzipping zipped file": DropIt 
Ret = FO.OpenFile(sFilPath & ".UnZ")  '-- write the unzipped file to disk.
  If Ret <> 0 Then ShowError1 Ret, "OpenFile to write unzipped data back to disk": DropIt  
Ret = FO.FileWrite(1, "zip")  
   If Ret <> 0 Then ShowError1 Ret, "FileWrite unzipped bytes": DropIt  
  FO.CloseFile  


'--------- end of main script. ------------------------

DropIt     

'----------------------------------------------------


Sub DropIt()
  Set FO = Nothing
  MsgBox "End of script.", 64
  WScript.Quit
End Sub

'----------------------------- end main script --------------------

Sub ShowError1(LErr, sMsg)  '-- create message for functions that return an error code.
  MsgBox "Error with: " & sMsg & vbCrLf & "Number: " & LErr & vbCrLf & "Desc.: " & FO.ErrorString
End Sub

Sub ShowError2(sMsg)  '-- create message for functions where ErrorNumber is set. These functions do not return an error number in the function itself.
  MsgBox "Error with: " & sMsg & vbCrLf & "Number: " & FO.ErrorNumber & vbCrLf & "Desc.: " & FO.ErrorString
End Sub